#################################################
#
#  (C) 2010-2011 Serghei Amelian
#  serghei (DOT) amelian (AT) gmail.com
#
#  Improvements and feedback are welcome
#
#  This file is released under GPL >= 2
#
#################################################

cmake_minimum_required( VERSION 2.8 )


##### general package setup #####################

project( tdenetworkmanager )
set( TDENETWORKMANAGER_VERSION "0.9" )


##### include essential cmake modules ###########

include( FindPkgConfig          )
include( CheckFunctionExists    )
include( CheckSymbolExists      )
include( CheckIncludeFile       )
include( CheckLibraryExists     )
include( CheckCSourceCompiles   )
include( CheckCXXSourceCompiles )


##### include our cmake modules #################

set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules" )
include( TDEMacros )


##### setup install paths #######################

include( TDESetupPaths )
tde_setup_paths( )

if( NOT DBUS_SYS_DIR )
  set( DBUS_SYS_DIR ${SYSCONF_INSTALL_DIR}/dbus-1/system.d )
endif( )


##### optional stuff ############################

option( WITH_ALL_OPTIONS    "Enable all optional support" OFF )
option( WITH_GCC_VISIBILITY "Enable fvisibility and fvisibility-inlines-hidden" ${WITH_ALL_OPTIONS} )
option( WITH_OPENVPN        "Enable openvpn support"                            ${WITH_ALL_OPTIONS} )
option( WITH_PPTP           "Enable pptp support"                               ${WITH_ALL_OPTIONS} )
option( WITH_VPNC           "Enable vpnc support"                               ${WITH_ALL_OPTIONS} )
option( WITH_STRONGSWAN     "Enable strongswan support"                         ${WITH_ALL_OPTIONS} )

# option( WITH_LDAP "Enable LDAP support" OFF )


##### user requested modules ####################

option( BUILD_ALL          "Build all"               OFF )
option( BUILD_DOC          "Build documentation"     ${BUILD_ALL} )
option( BUILD_TRANSLATIONS "Build translations"      ${BUILD_ALL} )


##### configure checks ##########################

include( ConfigureChecks.cmake )


###### global compiler settings #################

add_definitions( -DHAVE_CONFIG_H )

set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${TQT_CXX_FLAGS}" )
set( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined" )
set( CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined" )


##### source directories ########################

add_subdirectory( ${PROJECT_NAME} )


##### write configure files #####################

configure_file( config.h.cmake config.h @ONLY )
